VERSION 5.00
Begin VB.UserControl Pin 
   BackStyle       =   0  'Transparent
   CanGetFocus     =   0   'False
   ClientHeight    =   255
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2790
   ClipBehavior    =   0  'None
   ClipControls    =   0   'False
   HasDC           =   0   'False
   HitBehavior     =   0  'None
   ScaleHeight     =   255
   ScaleWidth      =   2790
   ToolboxBitmap   =   "Pin.ctx":0000
   Begin VB.Line lin2 
      BorderColor     =   &H00000000&
      X1              =   540
      X2              =   840
      Y1              =   120
      Y2              =   120
   End
   Begin VB.Label lblNumber 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      BackColor       =   &H0000C0F0&
      Caption         =   "__"
      ForeColor       =   &H00000000&
      Height          =   195
      Left            =   300
      TabIndex        =   1
      Top             =   15
      Width           =   180
   End
   Begin VB.Line lin3 
      BorderColor     =   &H80000012&
      X1              =   2400
      X2              =   2700
      Y1              =   120
      Y2              =   120
   End
   Begin VB.Line lin1 
      BorderColor     =   &H00000000&
      X1              =   180
      X2              =   315
      Y1              =   120
      Y2              =   120
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "Pin"
      Height          =   195
      Left            =   900
      TabIndex        =   0
      Top             =   15
      Width           =   225
   End
   Begin VB.Shape Light 
      BackColor       =   &H00000060&
      BackStyle       =   1  'Opaque
      BorderColor     =   &H00000000&
      BorderWidth     =   2
      Height          =   255
      Left            =   0
      Shape           =   3  'Circle
      Top             =   0
      Width           =   195
   End
End
Attribute VB_Name = "Pin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum STYLES
    pinLeft
    pinRight
    pinStub
End Enum

Private Const CONTROLWIDTH As Single = 2790
Private Const CONTROLHEIGHT As Single = 255
Private Const L1WIDTH As Single = 600
Private Const OFFSET As Single = 300

Private mStyle As STYLES
Private mValue As Boolean

Public Property Get Caption() As String
    Caption = lblCaption.Caption
End Property

Public Property Let Caption(ByVal RHS As String)
    With lblCaption
        .Caption = RHS
        lin3.X1 = .Left + .Width
    End With
    PropertyChanged "Caption"
End Property

Public Property Get Style() As STYLES
    Style = mStyle
End Property

Public Property Let Style(ByVal RHS As STYLES)
    mStyle = RHS
    With lin2
        Select Case mStyle
            Case pinLeft
                .Visible = True
                .X2 = .X1 + L1WIDTH
                lin3.X2 = CONTROLWIDTH
                lblCaption.Visible = True
                lin3.Visible = True
            Case pinRight
                .Visible = True
                .X2 = .X1 + L1WIDTH - OFFSET
                lin3.X2 = CONTROLWIDTH - OFFSET
                lblCaption.Visible = True
                lin3.Visible = True
            Case pinStub
                .Visible = False
                lblCaption.Visible = False
                lin3.Visible = False
        End Select
    End With
    Value = mValue
    With lblCaption
        .Left = lin2.X2
        lin3.X1 = .Left + .Width
    End With
    PropertyChanged "Style"
End Property

Public Property Get Value() As Boolean
    Value = mValue
End Property

Public Property Let Value(ByVal RHS As Boolean)
    mValue = RHS
    If mStyle = pinStub Then
        Light.BackColor = vbWhite
    Else
        If mValue Then
            Light.BackColor = &HFF&
        Else
            Light.BackColor = &H60&
        End If
    End If
    PropertyChanged "Value"
End Property

Private Sub UserControl_AmbientChanged(PropertyName As String)
    If Extender.Index >= 0 Then
        lblNumber.Caption = CStr(Extender.Index)
    Else
        lblNumber.Caption = "__"
    End If
End Sub

Private Sub UserControl_Initialize()
    FontWiz.AdjustControls Controls
    Caption = lblCaption.Caption
End Sub

Private Sub UserControl_InitProperties()
    If Extender.Index >= 0 Then
        lblNumber.Caption = CStr(Extender.Index)
    Else
        lblNumber.Caption = "__"
    End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    If Extender.Index >= 0 Then
        lblNumber.Caption = CStr(Extender.Index)
    Else
        lblNumber.Caption = "__"
    End If
    With PropBag
        Caption = .ReadProperty("Caption", "Pin")
        Style = .ReadProperty("Style", pinLeft)
        Value = .ReadProperty("Value", False)
    End With
End Sub

Private Sub UserControl_Resize()
    Static ResizingControl As Boolean
    
    If ResizingControl Then
        ResizingControl = False
    Else
        ResizingControl = True
        UserControl.Size CONTROLWIDTH, CONTROLHEIGHT
    End If
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "Caption", lblCaption.Caption, "Pin"
        .WriteProperty "Style", mStyle, pinLeft
        .WriteProperty "Value", mValue, False
    End With
End Sub
